"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getIosStatusAddressToolBarOffsets(iosOffsets) {
    var _a = window.screen, width = _a.width, height = _a.height;
    var isIphone = width < 1024 && height < 1024;
    var deviceType = isIphone ? 'IPHONE' : 'IPAD';
    var isLandscape = window.matchMedia('(orientation: landscape)').matches;
    var orientationType = isLandscape ? 'LANDSCAPE' : 'PORTRAIT';
    var defaultPortraitHeight = isIphone ? 667 : 1024;
    var portraitHeight = width > height ? width : height;
    var deviceWidth = isLandscape ? height : width;
    var offsetPortraitHeight = Object.keys(iosOffsets[deviceType]).indexOf(portraitHeight.toString()) > -1 ? portraitHeight : defaultPortraitHeight;
    var currentOffsets = iosOffsets[deviceType][offsetPortraitHeight][orientationType];
    var statusBarHeight = currentOffsets.STATUS_BAR;
    var osVersion = parseInt(navigator.appVersion.match(/(?:OS |Version\/)(\d+)(?:_|\.)(\d+)(?:_|\.)?(\d+)?/)[1], 10);
    var addressBarOnTop = (!isLandscape && isIphone && osVersion < 15) || isLandscape || !isIphone;
    var statusAddressBarHeight = statusBarHeight + (addressBarOnTop ? currentOffsets.ADDRESS_BAR : 0);
    var innerHeight = window.innerHeight;
    var toolBarHeight = height - innerHeight - statusAddressBarHeight;
    var toolBarOffsets = isLandscape || toolBarHeight <= 0
        ? currentOffsets.HOME_BAR
        : {
            height: toolBarHeight,
            width: deviceWidth,
            x: 0,
            y: height - toolBarHeight,
        };
    return {
        statusAddressBar: {
            height: statusAddressBarHeight,
            width: deviceWidth,
            x: 0,
            y: 0,
        },
        toolBar: toolBarOffsets,
    };
}
exports.default = getIosStatusAddressToolBarOffsets;
//# sourceMappingURL=getIosStatusAddressToolBarOffsets.js.map