import { Executor } from './methods.interface';
export interface RectanglesOptions {
    devicePixelRatio: number;
    isAndroidNativeWebScreenshot: boolean;
    innerHeight: number;
    isIos: boolean;
}
export interface ElementRectanglesOptions extends RectanglesOptions {
    isAndroid: boolean;
}
export interface ScreenRectanglesOptions extends RectanglesOptions {
    innerWidth: number;
    isAndroidChromeDriverScreenshot: boolean;
}
export interface RectanglesOutput {
    height: number;
    width: number;
    x: number;
    y: number;
}
export interface StatusAddressToolBarRectanglesOptions {
    isHybridApp: boolean;
    isMobile: boolean;
    isViewPortScreenshot: boolean;
    platformName: string;
    isAndroidNativeWebScreenshot: boolean;
    blockOutStatusBar: boolean;
    blockOutToolBar: boolean;
}
export declare type StatusAddressToolBarRectangles = Array<RectanglesOutput>;
export interface ElementRectangles {
    executor: Executor;
    base64Image: string;
    options: ElementRectanglesOptions;
    element: any;
}
