import { LogLevel } from '../helpers/options.interface';
export interface FullPageScreenshotsData {
    fullPageHeight: number;
    fullPageWidth: number;
    data: ScreenshotData[];
}
interface ScreenshotData {
    canvasWidth: number;
    canvasYPosition: number;
    imageHeight: number;
    imageWidth: number;
    imageYPosition: number;
    screenshot: string;
}
export interface FullPageScreenshotDataOptions {
    addressBarShadowPadding: number;
    devicePixelRatio: number;
    fullPageScrollTimeout: number;
    hideAfterFirstScroll: (HTMLElement | HTMLElement[])[];
    innerHeight: number;
    isAndroid: boolean;
    isAndroidNativeWebScreenshot: boolean;
    isAndroidChromeDriverScreenshot: boolean;
    isHybridApp: boolean;
    isIos: boolean;
    logLevel: LogLevel;
    toolBarShadowPadding: number;
}
export interface FullPageScreenshotNativeMobileOptions {
    addressBarShadowPadding: number;
    devicePixelRatio: number;
    fullPageScrollTimeout: number;
    innerHeight: number;
    logLevel: LogLevel;
    statusAddressBarHeight: number;
    toolBarShadowPadding: number;
    hideAfterFirstScroll: (HTMLElement | HTMLElement[])[];
}
export interface FullPageScreenshotOptions {
    devicePixelRatio: number;
    fullPageScrollTimeout: number;
    innerHeight: number;
    hideAfterFirstScroll: (HTMLElement | HTMLElement[])[];
    logLevel: LogLevel;
}
export {};
